-- blizzzard functions that no longer exist, or have been replaced across clients

ArkInventory.CrossClient = { }

function ArkInventory.CrossClient.GetProfessionInfo( ... )
	
	if GetProfessionInfo then
		
		return GetProfessionInfo( ... )
		
	else
		
		local index = ...
		local name = GetSkillLineInfo( index )
		
		for k, v in pairs( ArkInventory.Const.Skills.Data ) do
			if v.text == name then
				--ArkInventory.Output( "skill [", index, "] found [", name, "]=[", k, "]" )
				return name, "", 0, 0, 0, 0, k
			end
		end
		
		--ArkInventory.Output( "skill [", index, "] not found [", name, "]" )
		
	end
	
end

function ArkInventory.CrossClient.GetProfessions( ... )
	
	if GetProfessions then
		
		return GetProfessions( ... )
		
	else
		
		local skills = { }
		local skillnum = 0
		local header1 = string.lower( TRADE_SKILLS )
		local header2 = string.lower( SECONDARY_SKILLS )
		
		for k = 1, GetNumSkillLines( ) do
			local name, header = GetSkillLineInfo( k )
			--ArkInventory.Output( name, " / ", header )
			if header ~= nil then
				
				name = string.lower( name )
				
				if string.match( header1, name ) or string.match( header2, name ) then
					
					--ArkInventory.Output( "valid header = ", name )
					
					good = true
					
					if string.match( header2, name ) and skillnum < 2 then
						skillnum = 2
					end
					
				else
					
					good = false
					
				end
				
			else
				
				if good then
					skillnum = skillnum + 1
					--ArkInventory.Output( "skills[", skillnum, "] = ", k, " [", name, "]" )
					skills[skillnum] = k
				end
				
			end
		end
		
		return skills[1], skills[2], skills[3], skills[4], skills[5]
		
	end
	
end

function ArkInventory.CrossClient.SetSortBagsRightToLeft( ... )
	if SetSortBagsRightToLeft then
		return SetSortBagsRightToLeft( ... )
	end
end

function ArkInventory.CrossClient.GetContainerItemQuestInfo( ... )
	local b, s, i = ...
	if GetContainerItemQuestInfo then
		return GetContainerItemQuestInfo( b, s )
	else
		if ArkInventory.PT_ItemInSets( i.h, "ArkInventory.System.Quest.Start" ) then
			return true
		end
	end
end

function ArkInventory.CrossClient.IsArtifactPowerItem( ... )
	if IsArtifactPowerItem then
		return IsArtifactPowerItem( ... )
	end
end

function ArkInventory.CrossClient.IsReagentBankUnlocked( ... )
	if IsReagentBankUnlocked then
		return IsReagentBankUnlocked( ... )
	end
end

function ArkInventory.CrossClient.IsCorruptedItem( ... )
	if IsCorruptedItem then
		return IsCorruptedItem( ... )
	end
end

function ArkInventory.CrossClient.GetCurrencyInfo( ... )
	
	if GetCurrencyInfo then
		
		--name, CurrentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo( index )
		return GetCurrencyInfo( ... )
		
	elseif C_CurrencyInfo then
		
		local t = C_CurrencyInfo.GetCurrencyInfo( ... )
		if t then
			return t.name, t.quantity, t.iconFileID, t.quantityEarnedThisWeek, t.maxWeeklyQuantity, t.maxQuantity, t.discovered
		end
		
		--[[
		canEarnPerWeek
		isHeader
		isHeaderExpanded
		isShownInBackpack
		isTradeable
		isTypeUnused
		quality
		]]--
		
	end
	
end

function ArkInventory.CrossClient.GetCurrencyLink( ... )
	if GetCurrencyLink then
		return GetCurrencyLink( ... )
	elseif C_CurrencyInfo then
		return C_CurrencyInfo.GetCurrencyLink( ... )
	end
end

function ArkInventory.CrossClient.GetCurrencyListSize( ... )
	if GetCurrencyListSize then
		return GetCurrencyListSize( ... )
	elseif C_CurrencyInfo then
		return C_CurrencyInfo.GetCurrencyListSize( ... )
	end
end

function ArkInventory.CrossClient.GetCurrencyListInfo( ... )
	
	if GetCurrencyListInfo then
		
		return GetCurrencyListInfo( ... )
		
	elseif C_CurrencyInfo then
		
		local t = C_CurrencyInfo.GetCurrencyListInfo( ... )
		if t then
			return t.name, t.isHeader, t.isHeaderExpanded, t.isTypeUnused, nil, t.quantity, t.iconFileID
		end
		return
		
		--[[
		canEarnPerWeek
		discovered
		isShownInBackpack
		isTradeable
		maxWeeklyQuantity
		maxQuantity
		quality
		quantityEarnedThisWeek
		]]--
		
	end
end

function ArkInventory.CrossClient.GetBackpackCurrencyInfo( ... )
	if GetBackpackCurrencyInfo then
		return GetBackpackCurrencyInfo( ... )
	elseif C_CurrencyInfo then
		local t = C_CurrencyInfo.GetBackpackCurrencyInfo( ... )
		if t then
			return t.name, t.quantity, t.iconFileID, t.currencyTypesID
		end
		return
	end
end

function ArkInventory.CrossClient.GetCurrencyListLink( ... )
	if GetCurrencyListLink then
		return GetCurrencyListLink( ... )
	elseif C_CurrencyInfo then
		return C_CurrencyInfo.GetCurrencyListLink( ... )
	end
end

function ArkInventory.CrossClient.SetCurrencyUnused( ... )
	if SetCurrencyUnused then
		return SetCurrencyUnused( ... )
	elseif C_CurrencyInfo then
		return C_CurrencyInfo.SetCurrencyUnused( ... )
	end
end

function ArkInventory.CrossClient.GetFriendshipReputation( ... )
	if GetFriendshipReputation then
		return GetFriendshipReputation( ... )
	end
end

function ArkInventory.CrossClient.IsFactionParagon( ... )
	if C_Reputation then
		if C_Reputation.IsFactionParagon then
			return C_Reputation.IsFactionParagon( ... )
		end
	end
end
